#include <sys/types.h>
#include <utmp.h>

#ifdef pdp11
#include <wait.h>
#else pdp11
#include <sys/wait.h>
#endif pdp11

#include <sys/ioctl.h>
#include <sys/file.h>
#include "untamo.h"

#ifdef pdp11
#include <sys/param.h>
#define getdtablesize() NOFILE
#endif pdp11

extern char *malloc() , *ctime() , *strcpy();
time_t time();

/*
 * zap -- disconnect the person logged on to tty "dev".
 * 	  makes use of ioctl(2) to get a new controlling
 *	  terminal and the infinitely clever vhangup(2)
 * 	  to disconnect it.  
 */
zap(him, type)
struct user *him;
int type;
{
	static char message[] = "\n\n\007Logged out by the system.\n";
	int dts, td;

	/*
	 * close all the child's descriptors 
	 */
	dts = getdtablesize();
	for ( dts--; dts>=0; dts--){
		if (dts != fileno(logfp)) /* Don't close our logfile */
			(void) close(dts);
	}
	/*
	 * now tell him it's over, and disconnect.
	 */
	td = open(him->line, O_RDWR, 0600);
	(void) ioctl(td, TIOCSTART, (char *)0);
	if (td >= 0)  {
		(void) write(td, message, sizeof(message) );
#ifdef pdp11
		(void) fflush(td);
#else  pdp11
		(void) fsync(td);
#endif pdp11
		(void) ioctl(td, TIOCFLUSH, (char *)0);
		td = vhangup();
		Log("%s on %s because %s, vhangup returned %d",
			him->uid, him->line, 
			( (type & IS_MULT) ? "multiple" 
			: (type & IS_IDLE ? "idle" : "session" )), td );
	} else {
		Log("couldn't open %s on %s",
			him->line, him->uid);
	}
}


error(sb)
char *sb;
{
	Log(sb);
}
